/**
 * NeoPIXELRING
 * 
 * Uing 60 or any number of WS2812B/Neopixel LEDs 
 * 
 * Libraries needed:
 *   * Adafruit NeoPixel (Library Manager) - Phil Burgess / Paint Your Dragon for Adafruit Industries - LGPL3
 *   * 
 *  
 *   Add intensity driver wit an LDR on an analogue input!
 *   
 *   
 *   
 *   
 *   
 *   
 **/

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#if defined(ESP8266)
#include <pgmspace.h>
#else
#include <avr/pgmspace.h>
#endif

#include <Wire.h> // must be included here so that Arduino library object file references work

/* for normal hardware wire use above */
#define PIN 5
#define NUMPIXELS 60  // 128 for the dense one, 60 for the large round, 105 for large star, 148 for very large star and 64 for the smaller ones for the xmas star with the high density of 2812's

int (TIMING) = 15; // multiplication factor for the wait variable, if so needed was 2; higher = slower!!
int (mintiming)=12;//fastest
int (maxtiming)=15;//slowest
int (dimmer)=20;
int (dimmernormal)=30;
int (mindimmer)=20;//lowest intensity
int (maxdimmer)=160;//brightest intensity
int (scatterintensity)=55;
int (ij)=0;
int (ii)=0;
int (NUMPIXEL)= NUMPIXELS;
boolean fader=true;
const int ldrPin = A0; // analog pin 0, connected with photovaristor
int ldrStatus=0;// initialize variable val for light intensity variable infuencing

Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////
void setup() {
    
  Serial.begin(57600);
  pinMode(ldrPin, INPUT_PULLUP); // Here the LDR sensor is determined as input with an internal pull-up resistor.
  autodim();
  strip.begin();
  strip.setBrightness(dimmernormal);
  strip.clear();
  autodim(); strip.show(); // Initialize all pixels to 'off'
}// end of setup

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// VOID LOOP FOR A RING ONLY////
void loop(){

autodim();
dimmer=random(mindimmer,maxdimmer);
strip.setBrightness(dimmernormal);
TIMING=random(mintiming,maxtiming);

// START CONTENT:

 for(int ij=2;ij>=0;ij--){waveright(strip.Color(random(1,dimmer*4), 10*ij, 124-(ij*10)), TIMING/2);}

//return;


splitrun(strip.Color(255, 0, 0), strip.Color(0, 255, 0), TIMING);
splitwave(strip.Color(155, 155, 0), TIMING/2);

for(int ij=(random(50));ij>=0;ij--)multiscatter(strip.Color(255, 255, 255),TIMING/2); //  multiscatter WHITE   
for(int ij=(random(NUMPIXEL*3));ij>=0;ij--)scatterreplace(strip.Color(255, 255, 255),strip.Color(0, 0, 155),TIMING/4); //  scatter WHITE replace by BLUE
fadeout(TIMING/10);  

rainbowCycle(TIMING);
fadeout(TIMING/5);

splitwave(strip.Color(100,0, 0), TIMING);

 splitrun_single(strip.Color(155, 0, 155), TIMING);
 splitrun_single(strip.Color(155, 155, 0), TIMING/3);
 splitrun_single(strip.Color(155, 155, 155), TIMING);
 splitrun_single(strip.Color(0, 155, 155), TIMING/4);
 
windmill_R(strip.Color(255, 0, 0),strip.Color(0, 0, 0),TIMING/5);
for(int ij=(random(10));ij>=0;ij--)windmill_F(strip.Color(0, 255, 0),strip.Color(0, 0, 0),TIMING*2); //  windmill_Fast  

splitwave(strip.Color(dimmer, dimmer, 255), TIMING);

for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155, 155,155), TIMING/5);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155, 0,155), TIMING/5);}
delay(TIMING*10);
fade_out(TIMING/2);

for(int ij=10;ij>=0;ij--){waveright(strip.Color(155, 155, 0), TIMING/4);}
fade_out(TIMING/2);
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(dimmer*2, dimmer*2, 155), TIMING);}
fade_out(TIMING);
delay(TIMING*10);

splitrun(strip.Color(dimmer, 255, 0), strip.Color(0, dimmer, 0), TIMING);
rainbowCycle(TIMING);
splitrun_single(strip.Color(155, 155, 155), TIMING);

for(int ij=3;ij>0;ij--){
  dimmer=random(mindimmer,maxdimmer); 
  waveright(strip.Color(random(1,dimmer*2), 10*ij, 155), TIMING/1.5); 
  dimmer=random(mindimmer,maxdimmer); 
  waveright(strip.Color(random(1,255), 10*ij, 124-(ij*10)), TIMING/1.5); 
  }
rainbowCycle(TIMING);
fade_out(TIMING*5);
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(155, 155, 155),strip.Color(0, 0, mindimmer/4),TIMING); //  scatter WHITE, purple   
for(int ij=(random(40));ij>=0;ij--)scatterreplace(strip.Color(dimmer*155, 0, dimmer*155),strip.Color(0, 0, mindimmer/4),TIMING); //  scatter PURPLE   
for(int ij=(random(30));ij>=0;ij--)scatterreplace(strip.Color(0, dimmer*155, 0),strip.Color(0, 0, mindimmer/4),TIMING); //  scatter GREEN
for(int ij=(random(40));ij>=0;ij--)scatterreplace(strip.Color(0, 0, dimmer*155),strip.Color(0, 0, mindimmer/4),TIMING); //  scatter BLUE  
for(int ij=1;ij>0;ij--){waveleft_right(strip.Color(random(1,155-(dimmer*2)), 10*ij, 124-(ij*10)), TIMING/1.5);}
for(int ij=(random(1,10));ij>=0;ij--){explode(strip.Color(random(0,155), random(0,155), random (0,155)),TIMING*2);} 
for(int ij=1;ij>0;ij--){waveleft(strip.Color(random(1,dimmer*2), 155, 124-(ij*10)), TIMING/1.5);waveleft(strip.Color(0,0,0), TIMING/1.5);}

      for(int ij=3;ij>0;ij--){
        dimmer=random(mindimmer,maxdimmer); 
        waveright(strip.Color(random(1,dimmer*2), 10*ij, 155), TIMING/1.5); 
        dimmer=random(mindimmer,maxdimmer); 
        waveright(strip.Color(random(1,155), 10*ij, 124-(ij*10)), TIMING/1.5); 
        }
        
rainbowCycle(TIMING*4);
fade_out(TIMING*5);
splitrun_single(strip.Color(155, 155, 155), TIMING);
splitrun_single(strip.Color(0, 155, 155), TIMING);
splitrun_single(strip.Color(155, 155, 0), TIMING);
splitrun_single(strip.Color(155, 0, 155), TIMING);
splitrun_single(strip.Color(155, 155, 0), TIMING);
splitwave(strip.Color(dimmer, 0, 0), TIMING/4);
splitrun_single(strip.Color(155, 0, 155), TIMING);
splitrun_single(strip.Color(155, 155, 0), TIMING);
splitrun_single(strip.Color(155, 155, 155), TIMING/6);
splitrun_single(strip.Color(0, 155, 155), TIMING);

for(int ij=(random(20));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE 
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE   
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(dimmer*155, 0, dimmer*155),TIMING); //  scatter PURPLE   
for(int ij=(random(30));ij>=0;ij--)scatter(strip.Color(0, dimmer*155, 0),TIMING); //  scatter GREEN
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(0, 0, dimmer*155),TIMING); //  scatter BLUE       
fade_out(TIMING);

colorchanger(strip.Color(250, dimmer, 0), TIMING);
splitrun(strip.Color(dimmer, 155, 0), strip.Color(0, dimmer, 0), TIMING);
splitwave(strip.Color(dimmer, dimmer, 155), TIMING);
for(int ij=(random(1,10));ij>=0;ij--){explode(strip.Color(random(0,155), random(0,dimmer), random (0,155)),TIMING);}      
rainbow(TIMING);
for(int ij=10;ij>=0;ij--){flash_glow(strip.Color(dimmer*ij, 155,dimmer), TIMING);}
for(int ij=10;ij>=0;ij--){theaterChase(strip.Color(random(10,dimmer), random(0,dimmer*3), 124-(random(1,dimmer*4))), TIMING);} 

for(int ij=1;ij>=0;ij--){waveright_left(strip.Color(random(1,dimmer*2), 155, 124-(ij*10)), TIMING);}
colorWipeL(strip.Color(  155,   155, 0)     , TIMING*2); // Violet
colorWipeL(strip.Color(  155,   0, 0)     , TIMING*2); // R
colorWipeL(strip.Color(  0,   155, 0)     , TIMING*2); // G
colorWipeR(strip.Color(  250,   150, 0)     , TIMING*2); // Almost nothing
splitwave(strip.Color(155, 0, 0), TIMING*2);
splitwave(strip.Color(155, 0, 155), TIMING*2);

for(int ij=(random(10));ij>=0;ij--)windmill_F(strip.Color(0, 0, 155),strip.Color(0, 0, 0),TIMING*5); //  windmill_FAST  

for(int ij=(random(10));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE    
for(int ij=(random(20));ij>=0;ij--)scatter(strip.Color(dimmer*155, 0, dimmer*155),TIMING); //  scatter PURPLE   
for(int ij=(random(30));ij>=0;ij--)scatter(strip.Color(0, dimmer*155, 0),TIMING); //  scatter GREEN
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(0, 0, dimmer*155),TIMING); //  scatter BLUE 

colorWipeL(strip.Color(  dimmer,   dimmer, 200)     , TIMING*2); // Violet
colorWipeL(strip.Color(  dimmer,   200, 0)     , TIMING*2); // R
colorWipeL(strip.Color(  200,   dimmer, 0)     , TIMING*2); // G
colorWipeR(strip.Color(  5,   155, 0)     , TIMING*2); // Almost nothing
  
splitwave(strip.Color(dimmer, 0, 155), TIMING*2);
splitwave(strip.Color(dimmer, 155, dimmer), TIMING*2);
  
colorWipe(strip.Color(dimmer, 0, 155), TIMING*2); // Red
colorWipe(strip.Color(155, dimmer, 0), TIMING*2); // Green
colorWipe(strip.Color(0, 155, dimmer), TIMING*2); // Blue
colorWipe(strip.Color(dimmer, 0, 155), TIMING*2); // Red
goleft(strip.Color(dimmer, dimmer, 155), TIMING*2);
colorWipe(strip.Color(155, dimmer, dimmer), TIMING*2); // Green
goleft(strip.Color(dimmer, 155, dimmer), TIMING*2);
colorWipe(strip.Color(155, 0, dimmer), TIMING*2); // Blue
fade_out(TIMING*0.2);
delay(TIMING*2);
  
theaterChase(strip.Color(155, dimmer/2, dimmer/2), TIMING*2); // White
theaterChase(strip.Color(dimmer/2, 155, 0), TIMING*10); // Red
theaterChase(strip.Color(0, 155, dimmer/2), TIMING*5); // Blue
  
splitrun_single(strip.Color(155, 155, 0), TIMING);
splitrun_single(strip.Color(155, 155, 155), TIMING);
fade_out(TIMING*0.4);
  
rainbow(TIMING*3);
  
for(int ij=(random(100));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE   
   
rainbowCycle(TIMING);
fade_out(TIMING*0.2);
  
theaterChaseRainbow(TIMING*2);
fade_out(TIMING*0.5);
       
//return;

for(int ij=(random(20));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE 
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE    
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(dimmer*155, 0, dimmer*155),TIMING); //  scatter PURPLE   
for(int ij=(random(30));ij>=0;ij--)scatter(strip.Color(0, dimmer*155, 0),TIMING); //  scatter GREEN
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(0, 0, dimmer*155),TIMING); //  scatter BLUE       
  

 
  //fade_out(TIMING);
  colorchanger(strip.Color(50, dimmer, 0), TIMING);
  splitrun(strip.Color(dimmer, 0, 0), strip.Color(0, dimmer, 0), TIMING);
  splitwave(strip.Color(dimmer, dimmer, 0), TIMING);
  for(int ij=(random(1,10));ij>=0;ij--){explode(strip.Color(random(0,dimmer), random(0,dimmer), random (0,dimmer)),TIMING);}      
  rainbow(TIMING);
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer*ij, 0,dimmer), TIMING);}
  for(int ij=10;ij>=0;ij--){theaterChase(strip.Color(random(10,dimmer), random(0,dimmer*3), 124-(random(1,dimmer*4))), TIMING);} 
  goleft(strip.Color(dimmer,0, 0),TIMING/2);
  goright (strip.Color(0, dimmer, 0),TIMING);
  colorWipeL(strip.Color(dimmer, dimmer, 0), TIMING/2); // YELLOW 
  rainbowCycle(TIMING/5);
  for(int ij=10;ij>=0;ij--){waveright(strip.Color(random(1,dimmer*2), 10*ij, 124-(ij*10)), TIMING);}
  

 colorchanger(strip.Color(0, 155, 0), TIMING);
splitrun(strip.Color(155, 0, 0), strip.Color(55, 0, 0), TIMING*2);
splitwave(strip.Color(155, 155, 0), TIMING*2);
for(int ij=(random(1,10));ij>=0;ij--){explode(strip.Color(random(0,155), random(0,155), random (0,155)),TIMING*2);}      
colorchanger(strip.Color(155, 0, 0), TIMING);
rainbow(TIMING*2);
splitwave(strip.Color(155, 155, 155), TIMING*2);
for(int ij=5;ij>=0;ij--){waveright(strip.Color(ij*20, ij*40, 50), TIMING*2);}
for(int ij=5;ij>=0;ij--){theaterChase(strip.Color(ij*40, ij*40, 200-(ij*40)), TIMING*3);} 
goleft(strip.Color(50,0, 0),TIMING*2);
splitwave(strip.Color(0, 155, 155), TIMING*2);
colorchanger(strip.Color(155, 155, 155), TIMING);
goright (strip.Color(0, 155, 0),TIMING*2);
splitwave(strip.Color(155, 0, 0), TIMING*2);
colorWipeL(strip.Color(155, 155, 0), TIMING*2); // YELLOW 
splitwave(strip.Color(0, 0, 155), TIMING*2);
rainbowCycle(TIMING*2);
colorWipeL(strip.Color(  155,   155, 0)     , TIMING*2); // Violet
colorWipeL(strip.Color(  155,   0, 0)     , TIMING*2); // R
colorWipeL(strip.Color(  0,   155, 0)     , TIMING*2); // G
colorWipeR(strip.Color(  50,   50, 0)     , TIMING*2); // Almost nothing
splitwave(strip.Color(155, 0, 0), TIMING*2);
splitwave(strip.Color(155, 0, 155), TIMING*2);
  
for(int ij=(random(10));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE    
for(int ij=(random(20));ij>=0;ij--)scatter(strip.Color(dimmer*155, 0, dimmer*155),TIMING); //  scatter PURPLE   
for(int ij=(random(30));ij>=0;ij--)scatter(strip.Color(0, dimmer*155, 0),TIMING); //  scatter GREEN
for(int ij=(random(40));ij>=0;ij--)scatter(strip.Color(0, 0, dimmer*155),TIMING); //  scatter BLUE 

  for(int ij=10;ij>=0;ij--){waveright(strip.Color(random(1,dimmer*4), 10*ij, 124-(ij*10)), TIMING*2);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer/2, dimmer/2, dimmer/2), TIMING*3);}
  colorWipe(strip.Color(dimmer, 0, 0), TIMING*5); // Red
  goleft(strip.Color(dimmer, dimmer, 0), TIMING*5);
  colorWipe(strip.Color(0, dimmer, dimmer), TIMING*5); // Green
  goleft(strip.Color(dimmer, 0, dimmer), TIMING*5);
  goleft(strip.Color(0, dimmer, 0), TIMING*5);
  colorWipe(strip.Color(0, 0, dimmer), TIMING*5); // Blue
 fade_out(TIMING*0.5);
 delay(TIMING*2);
  theaterChase(strip.Color(dimmer/2, dimmer/2, dimmer/2), TIMING*5); // White
  theaterChase(strip.Color(dimmer, 0, 0), TIMING*50); // Red
  theaterChase(strip.Color(0, 0, dimmer/2), TIMING*5); // Blue

  rainbow(TIMING*3);
  rainbowCycle(TIMING);
  fade_out(TIMING*0.5);
  
  colorchanger(strip.Color(dimmer, 0, 0), TIMING);
  for(int ij=(random(20));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE    
  
  splitwave(strip.Color(dimmer, dimmer, dimmer), TIMING);
  
  
  
  
  splitwave(strip.Color(0, dimmer, dimmer), TIMING);
  colorchanger(strip.Color(dimmer, dimmer, dimmer), TIMING);
  fade_out(TIMING*0.5);
  splitrun_single(strip.Color(155, 155, 0), TIMING);
 splitrun_single(strip.Color(155, 155, 155), TIMING);
  splitwave(strip.Color(dimmer, 0, 0), TIMING*2);
  
  splitwave(strip.Color(0, 0, dimmer), TIMING*2);
  
  fade_out(TIMING*0.5);
  
  colorWipeL(strip.Color(  dimmer,   dimmer, 0)     , TIMING*2); // Violet
  colorWipeL(strip.Color(  dimmer,   0, 0)     , TIMING*2); // R
  colorWipeL(strip.Color(  0,   dimmer, 0)     , TIMING*2); // G
  colorWipeR(strip.Color(  5,   5, 0)     , TIMING*2); // Almost nothing
  splitwave(strip.Color(dimmer, 0, 0), TIMING*2);
  splitwave(strip.Color(dimmer, 0, dimmer), TIMING*2);
  colorWipe(strip.Color(dimmer, 0, 0), TIMING*2); // Red
  colorWipe(strip.Color(0, dimmer, 0), TIMING*2); // Green
  colorWipe(strip.Color(0, 0, dimmer), TIMING*2); // Blue
  colorWipe(strip.Color(dimmer, 0, 0), TIMING*2); // Red
  goleft(strip.Color(dimmer, dimmer, 0), TIMING*2);
  colorWipe(strip.Color(0, dimmer, dimmer), TIMING*2); // Green
  goleft(strip.Color(dimmer, 0, dimmer), TIMING*2);
  colorWipe(strip.Color(0, 0, dimmer), TIMING*2); // Blue
  fade_out(TIMING*0.2);
  delay(TIMING*2);
  theaterChase(strip.Color(dimmer/2, dimmer/2, dimmer/2), TIMING*2); // White
  theaterChase(strip.Color(dimmer/2, 0, 0), TIMING*10); // Red
  theaterChase(strip.Color(0, 0, dimmer/2), TIMING*5); // Blue
  splitrun_single(strip.Color(155, 155, 0), TIMING);
 splitrun_single(strip.Color(155, 155, 155), TIMING);
  fade_out(TIMING*0.4);
  rainbow(TIMING*3);
  for(int ij=(random(100));ij>=0;ij--)scatter(strip.Color(dimmer*155, dimmer*155, dimmer*155),TIMING); //  scatter WHITE    
  rainbowCycle(TIMING);
  fade_out(TIMING*0.2);
  theaterChaseRainbow(TIMING*2);
  fade_out(TIMING*0.5);
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer, dimmer, dimmer), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer, 0, dimmer), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer, dimmer, 0), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(0, dimmer, dimmer), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(0, dimmer, 0), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(0, 0, dimmer), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer, 0, dimmer), TIMING*30);}
  for(int ij=10;ij>=0;ij--){flash(strip.Color(dimmer, 0, 0), TIMING*30);}





theaterChaseRainbow(TIMING/2);
fade_out(TIMING/5);

for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(155, 155, 155),strip.Color(155, 155, 155),TIMING); //  scatter WHITE, replace with blue   
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(155, 0, 0),strip.Color(155, 0, 0),TIMING); //  scatter GREEN, replace with green   
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(0, 155, 0),strip.Color(0, 155,0),TIMING); //  scatter RED
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(155, 0, 155),strip.Color(155, 0, 155),TIMING); //  scatter BLUE  
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(155, 155,0),strip.Color(155, 155, 0),TIMING); //  scatter YELLOW  
for(int ij=(random(NUMPIXEL));ij>=0;ij--)scatterreplace(strip.Color(0, 155,155),strip.Color(0,155, 155),TIMING); //  scatter PURPLE
fadeout(TIMING);

rainbowCycle(TIMING);
fadeout(TIMING/5);

for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155, 155,155), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155, 0,0), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(0, 155,0), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(0, 155,155), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(0, 0,155), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155, 155,0), TIMING/2);}
for(int ij=0;ij>=0;ij--){flash_glow(strip.Color(155,0,155), TIMING/2);}
delay(TIMING*10);

colorWipeL(strip.Color(  dimmer,   dimmer, 200)     , TIMING*2); // Violet
colorWipeR(strip.Color(  dimmer,   200, 0)     , TIMING/2); // R
colorWipeL(strip.Color(  200,   dimmer, 200)     , TIMING/2); // G
colorWipeR(strip.Color(  0,   0, 200)     , TIMING*2); // Almost nothing

rainbowCycle(TIMING);
fade_out(TIMING/5);

theaterChase(strip.Color(155, 0, 0), TIMING*2); // GREEN
theaterChase(strip.Color(0, 155, 0), TIMING); // Red
theaterChase(strip.Color(155, 155, 155), TIMING/2); // WHITE
theaterChase(strip.Color(155, 155, 155), TIMING/2); // WHITE
theaterChase(strip.Color(155, 155, 155), TIMING/2); // WHITE

rainbowCycle(TIMING);
fade_out(TIMING*0.2);
       
}//end of loop
 //////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from center top (12 o'çlock) counter clockwise 
void colorWipeL(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
   strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from center right (3 o'çlock) counter clockwise 

void colorWipeL3(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    ij=i+(NUMPIXEL*0.25);
    if (i>=(NUMPIXEL*0.75)){
    ij=i-(NUMPIXEL*0.75);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
   strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from bottom (6 o'çlock) counter clockwise 

void colorWipeL6(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    ij=i+(NUMPIXEL*0.5);
    if (i>=(NUMPIXEL*0.5)){
    ij=i-(NUMPIXEL*0.5);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
    strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from center left(9 o'çlock) counter clockwise 

void colorWipeL9(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    ij=i+(NUMPIXEL*0.75);
    if (i>=(NUMPIXEL*0.25)){
    ij=i-(NUMPIXEL*0.25);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
    strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from random start counter clockwise 

void colorWipeLrandom(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  ii=random(NUMPIXEL);
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    ij=i+ii;
    if (i>=ii){
    ij=i-ii;}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
  strip.setBrightness(dimmernormal);
      autodim(); 
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from top (12 o'clock) clockwise
void colorWipeR(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=strip.numPixels(); i>=0; i--) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
  strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from center right (3 o'çlock) clockwise 

void colorWipeR3(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=strip.numPixels(); i>=0; i--) { // For each pixel in strip...
 
    ij=i+(NUMPIXEL*0.25);
    if (i>=(NUMPIXEL*0.75)){
    ij=i-(NUMPIXEL*0.75);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
    strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from bottom (6 o'çlock) clockwise 

void colorWipeR6(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=strip.numPixels(); i>=0; i--) { // For each pixel in strip...
 
    ij=i+(NUMPIXEL*0.5);
    if (i>=(NUMPIXEL*0.5)){
    ij=i-(NUMPIXEL*0.5);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
   strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from center left(9 o'çlock) clockwise 

void colorWipeR9(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  for(int i=strip.numPixels(); i>=0; i--) { // For each pixel in strip...
    ij=i+(NUMPIXEL*0.75);
    if (i>=(NUMPIXEL*0.25)){
    ij=i-(NUMPIXEL*0.25);}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
 strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
// go round from random start clockwise 

void colorWipeRrandom(uint32_t color, int wait) {
   strip.setBrightness(dimmernormal);
  ii=random(NUMPIXEL);
  for(int i=strip.numPixels(); i>=0; i--) { // For each pixel in strip...
    ij=i+ii;
    if (i>=ii){
    ij=i-ii;}
    strip.setPixelColor(ij, color);         //  Set pixel's color (in RAM)
    autodim(); strip.show();                          //  Update strip to match
    delay(wait*TIMING);                           //  Pause for a moment
  }
  
     strip.setBrightness(dimmernormal);
      autodim(); 
}
/////////////////////////////////////////////////////////////
//Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
   strip.setBrightness(dimmernormal);
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
    strip.setBrightness(dimmernormal);
      autodim(); 
  }}
/////////////////////////////////////////////////////////////
//Flash_glow ON and OFF with a slow ON and OFF at full intensity 1x on and off
void flash_glow(uint32_t c, uint8_t wait) {
   strip.setBrightness(dimmernormal);
  
        for(uint16_t i=0; i<strip.numPixels(); i++) {
        strip.setPixelColor(i, c);
        //strip.show();
        //delay(wait);
        }

 // fade in
            for(int i=1;i<(dimmernormal);i++){      
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING*2); // Delay for a period of time (in milliseconds).
            }


       
// fade out
            for(int i=(dimmernormal);i>0;i--){
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING); // Delay for a period of time (in milliseconds).
            }
            
   

    strip.setBrightness(dimmernormal);
      autodim(); 
    
 }
 /////////////////////////////////////////////////////////////
//Flash ON and OFF at full intensity 1x on and off
void flash(uint32_t c, uint8_t wait) {
   strip.setBrightness(dimmernormal);

  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    //strip.show();
    //delay(wait);
  }
  
  strip.show();
  delay(wait);
  strip.clear();
  strip.show();
  delay(wait);
  
     strip.setBrightness(dimmernormal);
      autodim(); 
 }
///////////////////////////////////////////////////////////////////
void rainbow(uint8_t wait) {
  uint16_t i, j;
  strip.setBrightness(dimmernormal);
  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 25));
    }
    strip.show();
    delay(wait);
  }
  strip.setBrightness(dimmernormal);
      autodim(); 
}
/////////////////////////////////////////////////////////////////////////////////////////////
// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;
    strip.setBrightness(dimmernormal);
  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
  
     strip.setBrightness(dimmernormal);
      autodim(); 
}
///////////////////////////////////////////////////////////////////////////////////
//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  strip.setBrightness(dimmernormal);
  for (int j=0; j<4; j++) {  //do 4  cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();
      delay(wait*TIMING);
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
  
  strip.setBrightness(dimmernormal);
      autodim(); 
}
////////////////////////////////////////////////////////////////////////////////////////////
//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
   strip.setBrightness(dimmernormal);
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait*TIMING);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
  
   strip.setBrightness(dimmernormal);
      autodim(); 
}
//////////////////////////////////////////////////////////////////////////////
// Input a value 0 to dimmer to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  strip.setBrightness(dimmernormal);
      autodim();  
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void goleft(uint32_t c,uint8_t wait){
 for(int i=NUMPIXELS;i>=0;i--){
   strip.setBrightness(dimmernormal);
//LEFT
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    strip.setPixelColor(i,c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
 //   strip.clear();
 strip.setBrightness(dimmernormal);
      autodim(); 
  }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void goright(uint32_t c,uint8_t wait){
 for(int i=0;i<=NUMPIXELS;i++){
   strip.setBrightness(dimmernormal);
 //RIGHT
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    strip.setPixelColor(i, c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
 //   strip.clear();
 strip.setBrightness(dimmernormal);
      autodim(); 
  }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  void explode(uint32_t c, uint8_t wait){
//Exploded star
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
     strip.setBrightness(dimmernormal);
    for(int ii=(NUMPIXELS/5);ii>=0;ii--){
    strip.setPixelColor(ii, c); // 
    strip.setPixelColor(ii+(NUMPIXELS/5), c); // 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), c); // 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), c); // 
    strip.setPixelColor(ii+(3*NUMPIXELS/5), c); // 
    strip.setPixelColor(ii+(4*NUMPIXELS/5), c); // 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
 //   strip.clear();
 strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
    void waveright(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=(NUMPIXELS/5);ii>=0;ii--){
    strip.setPixelColor(ii, c);
    strip.setPixelColor(ii+(NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5), c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
                                         }
//   strip.clear(); 
 strip.setBrightness(dimmernormal);
      autodim();                                         
}
//////////////////////////////////////////////////////////////////////////////////////////////////////
    void waveleft(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=0;ii<=(NUMPIXELS/5);ii++){
    strip.setPixelColor(ii,c );
    strip.setPixelColor(ii+(NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5),c ); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
//   strip.clear();
strip.setBrightness(dimmernormal);
      autodim();  
  }  
//////////////////////////////////////////////////////////////////////////////////////////////////////
    void waveright_left(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=(NUMPIXELS/5);ii>=0;ii--){
    strip.setPixelColor(ii, c);
    strip.setPixelColor(ii+(NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5), c); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5), c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
delay(wait*TIMING*8);
 for(int ii=0;ii<=(NUMPIXELS/5);ii++){
    strip.setPixelColor(ii, strip.Color(0,0,0));
    strip.setPixelColor(ii+(NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
//   strip.clear();
strip.setBrightness(dimmernormal);
      autodim();  
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
    void waveleft_right(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=0;ii<=(NUMPIXELS/5);ii++){
    strip.setPixelColor(ii,c );
    strip.setPixelColor(ii+(NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5),c ); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5),c ); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}

delay(wait*TIMING*8);
    
    for(int ii=(NUMPIXELS/5);ii>=0;ii--){
    strip.setPixelColor(ii, strip.Color(0,0,0));
    strip.setPixelColor(ii+(NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(2*NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(3*NUMPIXELS/5), strip.Color(0,0,0)); 
    strip.setPixelColor(ii+(4*NUMPIXELS/5), strip.Color(0,0,0));  
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
    
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
//   strip.clear();
strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
     void splitwave(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=(NUMPIXELS/2);ii>=0;ii--){
    strip.setPixelColor(ii, c);
    strip.setPixelColor(((NUMPIXELS)-ii), c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
delay(wait*TIMING*8);
 for(int ii=0;ii<=(NUMPIXELS/2);ii++){
    strip.setPixelColor(ii, strip.Color(0,0,0));
    strip.setPixelColor(((NUMPIXELS)-ii), strip.Color(0,0,0)); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
 //  strip.clear();
 strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
     void splitrun(uint32_t c, uint32_t d, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=(NUMPIXELS/2);ii>=0;ii--){
    strip.setPixelColor(ii, c);
    strip.setPixelColor(((NUMPIXELS)-ii), c); 
        strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
 for(int ii=(NUMPIXELS/2);ii>=0;ii--){
    strip.setPixelColor(ii, d);
    strip.setPixelColor(((NUMPIXELS)-ii), d); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
     void splitrun_single(uint32_t c, uint8_t wait){
       strip.setBrightness(dimmernormal);
    // pixels.Color takes RGB values, from 0,0,0 up to dimmer,dimmer,dimmer
    for(int ii=(NUMPIXELS/2);ii>=0;ii--){
    strip.setPixelColor(ii, c);
    strip.setPixelColor(((NUMPIXELS)-ii), c); 
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
strip.setBrightness(dimmernormal);
      autodim(); 
     }
//////////////////////////////////////////////////////////////////////////////////////////////////////
       void colorchanger (uint32_t c, uint8_t wait){
         strip.setBrightness(dimmernormal);
for(int i=(15);i<180;i++){
              for(int ii=(NUMPIXELS);ii>=0;ii--){
            strip.setPixelColor(ii, c);
              strip.setBrightness(i);
              }
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}   
    for(int i=(dimmernormal);i>5;i--){
              for(int ii=(NUMPIXELS);ii>=0;ii--){
            strip.setPixelColor(ii, c);
              strip.setBrightness(i);
              }
    strip.show(); // This sends the updated pixel color to the hardware.
    delay(wait*TIMING); // Delay for a period of time (in milliseconds).
}
  strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////
       void fade_out(uint8_t wait){
         strip.setBrightness(dimmernormal);

// glow off
            for(int i=(dimmernormal);i>0;i--){
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING); // Delay for a period of time (in milliseconds).
            }
      strip.clear();      
      strip.setBrightness(dimmernormal);
      autodim(); 

     }
 /////////////////////////////////////////////////////////////
//Scatter high intensity once with defined color at 1 randomly defined pixel around the globe
void scatter(uint32_t c, uint8_t wait) {
  strip.setBrightness(scatterintensity);
      strip.setPixelColor(random(NUMPIXELS),c);
    strip.show();
  delay(wait*10);
  strip.clear();
  strip.show(); // This sends the updated pixel color to the hardware.
  delay(wait*10);
  strip.setBrightness(dimmernormal);
      autodim(); 
  }
 /////////////////////////////////////////////////////////////
 //Mukltiscatter high intensity multiple leds with defined color at multiple randomly defined pixel around the globe
void multiscatter(uint32_t c, uint8_t wait) {
  strip.setBrightness(scatterintensity);
      strip.setPixelColor(random(NUMPIXELS),c);
      strip.setPixelColor(random(NUMPIXELS),c);
      strip.setPixelColor(random(NUMPIXELS),c);
      strip.setPixelColor(random(NUMPIXELS),c);
      strip.setPixelColor(random(NUMPIXELS),c);
    strip.show();
  delay(wait*10);
  strip.clear();
  strip.show(); // This sends the updated pixel color to the hardware.
  delay(wait*10);
  strip.setBrightness(dimmernormal);
      autodim(); 
  }
 /////////////////////////////////////////////////////////////
//Scatter high intensity to full circle with defined color per individually randomly defined pixel around the globe
void scatterfull(uint32_t c, uint8_t wait) {
  strip.setBrightness(scatterintensity);
      strip.setPixelColor(random(NUMPIXELS),c);
    strip.show();
  delay(wait*10);
  //strip.clear();
    strip.show(); // This sends the updated pixel color to the hardware.
  delay(wait*10);
  strip.setBrightness(dimmernormal);
      autodim(); 
  }
/////////////////////////////////////////////////////////////
//Scatter high intensity to full circle with defined color per individually randomly defined pixel around the globe
void scatterreplace(uint32_t c, uint32_t d, uint8_t wait) {
  
  strip.setBrightness(scatterintensity);
  int (ii)=random(NUMPIXEL);
      strip.setPixelColor(ii,c);
    strip.show();
  delay(wait*10);
  strip.setPixelColor(ii,d);
     strip.show(); // This sends the updated pixel color to the hardware.
  delay(wait*10);
  strip.setBrightness(dimmernormal);

  
       autodim();   
  }
  /////////////////////////////////////////////////////////////
//Multiscatterreplace high intensity to full circle with defined colors per couple of randomly defined pixels around the globe
void multiscatterreplace(uint32_t c, uint32_t d, uint8_t wait) {

for(int iji=0;ij<=5;ij++){
  
  strip.setBrightness(scatterintensity);
  int (ii)=random(NUMPIXEL);
      strip.setPixelColor(ii,c);
    strip.show();
  delay(wait*10);
  strip.setPixelColor(ii,d);
     strip.show(); // This sends the updated pixel color to the hardware.
  delay(wait*10);
}
  strip.setBrightness(dimmernormal);
       autodim();   
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Set color of strip
void setstripcolor(uint32_t c) {
   strip.setBrightness(dimmernormal);
  
  for(int ii=0;ii<=(NUMPIXELS);ii++){ strip.setPixelColor(ii,c ); strip.show();} // This sends the updated pixel color to the hardware.  
     strip.setBrightness(dimmernormal);
      autodim(); 
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Create a windmill illusion of turning triangles
void windmill_R(uint32_t c, uint32_t d, uint8_t wait) {
strip.setBrightness(scatterintensity);
int add=NUMPIXELS/5;

// Define triangle A
// Pixels 1-15, 26-35

        for(uint16_t i=0; i<(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/2)-1; i<(strip.numPixels()/1.5)+1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/1.12); i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
             }
        
             ;strip.show();
             fadein_fadeout(wait/10);
       // delay(wait*TIMING);
           //  strip.clear();
// Define triangle B


for(uint16_t i=-1+add/2; i<add+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=add+(strip.numPixels()/2)-1; i<add+(strip.numPixels()/1.5)+1; i++) {
        strip.setPixelColor(i, c);
            }

  //      for(uint16_t i=add+(strip.numPixels()/1.12); i<add+(strip.numPixels()); i++) {
   //     strip.setPixelColor(i, c);
     //        }
        
             ;strip.show();
             fadein_fadeout(wait/10);
      //  delay(wait*TIMING);
            //  strip.clear();

// Define triangle C


for(uint16_t i=-1+add*1.5; i<add*2+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=add*2+(strip.numPixels()/2)-1; i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
            }

        for(uint16_t i=0; i<((strip.numPixels()/10)); i++) {
        strip.setPixelColor(i, c);
             }
        
             ;strip.show();
             fadein_fadeout(wait/10);
      //  delay(wait*TIMING);
           //   strip.clear();

// Define triangle D


for(uint16_t i=-1+add*2.5; i<add*3+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/10)-1; i<(strip.numPixels())/3.5; i++) {
        strip.setPixelColor(i, c);
            }

   
        
             ;strip.show();
             fadein_fadeout(wait/10);
      //  delay(wait*TIMING);
           //   strip.clear();

// Define trangle E
  
  
for(uint16_t i=(strip.numPixels()/3.5); i<(strip.numPixels()/2); i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/1.43); i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
            }

     for(uint16_t i=0; i<(strip.numPixels()/10); i++) {
        strip.setPixelColor(i, c);
            }
        
             ;strip.show();
             fadein_fadeout(wait/10);
       // delay(wait*TIMING);
             // strip.clear();

 

  strip.setBrightness(dimmernormal);
       autodim();   
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
//Create a FAST windmill illusion of turning triangles
void windmill_F(uint32_t c, uint32_t d, uint8_t wait) {
strip.setBrightness(scatterintensity);
int add=NUMPIXELS/5;

// Define triangle A
// Pixels 1-15, 26-35

        for(uint16_t i=0; i<(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/2)-1; i<(strip.numPixels()/1.5)+1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/1.12); i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
             }
        
             ;strip.show();
           //  fadein_fadeout(wait/10);
        delay(wait*TIMING);
            strip.clear();
// Define triangle B


for(uint16_t i=-1+add/2; i<add+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=add+(strip.numPixels()/2)-1; i<add+(strip.numPixels()/1.5)+1; i++) {
        strip.setPixelColor(i, c);
            }

  //      for(uint16_t i=add+(strip.numPixels()/1.12); i<add+(strip.numPixels()); i++) {
   //     strip.setPixelColor(i, c);
     //        }
        
             ;strip.show();
           //  fadein_fadeout(wait/10);
        delay(wait*TIMING);
              strip.clear();

// Define triangle C


for(uint16_t i=-1+add*1.5; i<add*2+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=add*2+(strip.numPixels()/2)-1; i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
            }

        for(uint16_t i=0; i<((strip.numPixels()/10)); i++) {
        strip.setPixelColor(i, c);
             }
        
             ;strip.show();
        //     fadein_fadeout(wait/10);
        delay(wait*TIMING);
              strip.clear();

// Define triangle D


for(uint16_t i=-1+add*2.5; i<add*3+(strip.numPixels()/3)-1; i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/10)-1; i<(strip.numPixels())/3.5; i++) {
        strip.setPixelColor(i, c);
            }

   
        
             ;strip.show();
          //   fadein_fadeout(wait/10);
        delay(wait*TIMING);
              strip.clear();

// Define trangle E
  
  
for(uint16_t i=(strip.numPixels()/3.5); i<(strip.numPixels()/2); i++) {
        strip.setPixelColor(i, c);
             }

        for(uint16_t i=(strip.numPixels()/1.43); i<(strip.numPixels()); i++) {
        strip.setPixelColor(i, c);
            }

     for(uint16_t i=0; i<(strip.numPixels()/10); i++) {
        strip.setPixelColor(i, c);
            }
        
             ;strip.show();
           //  fadein_fadeout(wait/10);
        delay(wait*TIMING);
              strip.clear();

 

  strip.setBrightness(dimmernormal);
       autodim();   
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void fadein_fadeout(uint8_t wait){
// fade in
            for(int i=1;i<(dimmernormal);i++){      
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING/50); // Delay for a period of time (in milliseconds).
            }
      delay(wait*TIMING); // Delay for a period of time (in milliseconds).
// fade out
            for(int i=(dimmernormal);i>0;i--){
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING/25); // Delay for a period of time (in milliseconds).
            }
            strip.clear();
            autodim();
}
////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void fadeout(uint8_t wait){
// fade out
            for(int i=(dimmernormal);i>0;i--){
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING/25); // Delay for a period of time (in milliseconds).
            }
            strip.clear();
            autodim();
}
////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void fadein(uint8_t wait){
// fade in
            for(int i=1;i<(dimmernormal);i++){      
                      for(int ii=(NUMPIXELS);ii>=0;ii--){
                       strip.setBrightness(i);
                        }
            strip.show(); // This sends the updated pixel color to the hardware.
            delay(wait*TIMING/50); // Delay for a period of time (in milliseconds).
            }
      delay(wait*TIMING); // Delay for a period of time (in milliseconds).
autodim();
}
////////////////////////////////////////////////////////////////////////
//redefine dimmer, mindimmer and maxdimmer here, related to ldrStatus!
void autodim(){ 
ldrStatus = analogRead(ldrPin);//read the analog value of the light sensor, in darkness= approx. 1000 and brightest = approx. 10
dimmernormal=3+(1030-ldrStatus)/2;// was 3
//dimmernormal=150;// fixed light inmtensity
mindimmer=dimmernormal;
dimmer=dimmernormal;
maxdimmer=dimmernormal+5;
scatterintensity=dimmernormal+8;
strip.setBrightness(dimmernormal);
Serial.print("ldRstatus = : ");;
Serial.print(ldrStatus);;
Serial.print(" ; dimmernormal = : ");;
Serial.print(dimmernormal);
Serial.print(" ; dimmer = : ");;
Serial.println(dimmer);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
